/* audio file ξɽ
 * 10/15 2000
 * shige
 * aufinfo.c
 *
 * $Id: aufinfo.c,v 1.5 2000-11-03 19:57:33+09 shige Exp $
 */ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sndio.h"
#include "wavio.h"
#include "aiffio.h"
#include "error.h"

enum { BlockSize=0, DataSize=1, DataOffset=2,
       allparams=3 };

/* ####### prototype declaration ####### */
int main(int argc,char *argv[]);
int getarg(int argc,char *argv[],int *Mode,int param[]);
long int getfilesize(FILE *file);
void putlongwav(char *fname,long int fsize,WAVdata *wd,Chunk *ch,
		int chunks,int param[]);
void putlongaiff(char *fname,long int fsize,AIFFdata *ad,Chunk *ch,
		int chunks,int param[]);
void putchunklist(Chunk *ch,int chunks);
void putlongau(char *fname,long int fsize,Snddata *sd,int param[]);
void putdefaultheader(int param[]);
void putwav(char *fname,long int fsize,WAVdata *wd,int param[]);
void putaiff(char *fname,long int fsize,AIFFdata *ad,int param[]);
void putau(char *fname,long int fsize,Snddata *sd,int param[]);
void usage(void);

/* ##### main routine ##### */
int main(int argc,char *argv[])
{
    char magic[4];
    int mode=0,param[allparams];
    int j,k=0,ret;
    long int totalfilesize;
    FILE *file;
    WAVdata wd;
    AIFFdata ad;
    Snddata sd;
    Chunk ch[Maxchunks];
    
    if((j=getarg(argc,argv,&mode,param))<0
       ||(mode!=0 && mode!=1)){
	usage(); return Exit_getarg;
    }
    for(;j<argc;j++){
	if((file=fopen(argv[j],"r"))==NULL)
	  fprintf(stderr,"File [%s] does not opened.\n",argv[j]);
	else{ /* 1 file ν */
	    if((totalfilesize=getfilesize(file))<4) return Exit_errorfile;
	    rewind(file); 
	    /* magic  */
	    fread(magic,4,1,file);
	    if(strncmp(magic,"RIFF",4)==0){ /* WAV */
		if(mode==1){
		    if((ret=getWAVinfo(file,&wd,ch))<0)
		      fprintf(stderr,"getWAVinfo() error.(%s)\n",argv[j]);
		    else 
		      putlongwav(argv[j],totalfilesize,&wd,ch,ret,param);
		}
		else if(mode==0){
		    if((ret=getWAVheader(file,&wd))<0)
		      fprintf(stderr,"getWAVheader() error.(%s)\n",argv[j]);
		    else{ 
			if(++k==1) putdefaultheader(param);
			putwav(argv[j],totalfilesize,&wd,param);
		    }
		}
	    }
	    else if(strncmp(magic,"FORM",4)==0){ /* AIFF */
		if(mode==1){
		    if((ret=getAIFFinfo(file,&ad,ch))<0)
		      fprintf(stderr,"getAIFFinfo() error.(%s)\n",argv[j]);
		    else
		      putlongaiff(argv[j],totalfilesize,&ad,ch,ret,param);
		}
		else if(mode==0){
		    if((ret=getAIFFheader(file,&ad))<0)
		      fprintf(stderr,"getAIFFheader() error.(%s)\n",argv[j]);
		    else{
			if(++k==1) putdefaultheader(param);
			putaiff(argv[j],totalfilesize,&ad,param);
		    }
		}
	    }
	    else if(strncmp(magic,".snd",4)==0){ /* AU */
		if((ret=getSndheader(file,&sd))<0)
		  fprintf(stderr,"getSndheader() error.(%s)\n",argv[j]);
		else if(mode==1) putlongau(argv[j],totalfilesize,&sd,param);
		else if(mode==0){
		    if(++k==1) putdefaultheader(param);
		    putau(argv[j],totalfilesize,&sd,param);
		}
	    }
	    else{ /* error */
		fprintf(stderr,"File [%s] is not supported format.\n",argv[j]);
#ifdef DEBUG1
		printf("[%c%c%c%c]\n",magic[0],magic[1],magic[2],magic[3]);
#endif
		return Exit_unsupported_format;
	    } 
	    fclose(file);
	}
    }
    return No_err;
}

/* ##### get argument ##### */
/* return value: file name start offset
*/
int getarg(int argc,char *argv[],int *Mode,int param[])
{
    int j,inoption;
    char c;

    if(argc<2) return Err_argnum;
    for(j=1;j<=allparams;j++) param[j-1]=0;
    j=1;
    if(*argv[j]=='-'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'm':
		if(*++argv[j]=='\0' && ++j>=argc) return Err_argnum;
		if((*Mode=*argv[j]-'0')<0) return Err_bad_value;
		inoption=0;
		break;
	    case 'b': param[BlockSize]=1; inoption=1; break;
	    case 't': param[DataSize]=1; inoption=1; break;
	    case 's': param[DataOffset]=1; inoption=1; break;
	    case '\0': /* return j; */
		/* stdin is not support */
	    default: return Err_unknown_option;
	    }
	    if(inoption && (c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc) return Err_argnum;
	    if(*argv[j]!='-') break;
	    c=*(++argv[j]);
	}
    }
    return j;
}


/* ##### file size ֤ ##### */
long int getfilesize(FILE *file)
{
    if(file==NULL) return -1;
    fseek(file,0L,SEEK_END);
    return ftell(file);
}


/* ##### ϴؿ (Ĺ) ##### */
void putlongwav(char *fname,long int fsize,WAVdata *wd,Chunk *ch,
		int chunks,int param[])
{
    printf("%s : WAV, %ld Byte\n",fname,fsize);
    printf("  formatID: %04xH",wd->fmcode);
    switch(wd->fmcode){
    case 1: printf(" (linear)\n"); break;
    case 6: printf(" ( A-Law)\n"); break;
    case 7: printf(" (mu-Law)\n"); break;
    default: printf(" (unknown encoding)\n"); break;
    } 
    printf("  channel      : %d\n",wd->channel);
    printf("  samplingrate : %ld\n",wd->smplrate);
    printf("  byte/sec     : %ld\n",wd->bytepersec);
    printf("  blocksize    : %d\n",wd->blocksize);
    printf("  bit/sample   : %d\n",wd->bitpersmpl);
    if(wd->blocksize!=0)
      printf("  totalblocks  : %ld\n",wd->datalen/wd->blocksize);
    printf("  dataoffset   : %ld\n",wd->hlen);
    printf("  datasize     : %ld\n",wd->datalen);
    putchunklist(ch,chunks);
    printf("\n");
}

void putlongaiff(char *fname,long int fsize,AIFFdata *ad,Chunk *ch,
		int chunks,int param[])
{
    printf("%s : AIFF, %ld Byte\n",fname,fsize);
    printf("  format: (linear)\n");
    printf("  channel      : %d\n",ad->channel);
    printf("  samplingrate : %f\n",(ad->smplrate).x);
    printf("  byte/sec     : %f\n",(ad->smplrate).x*(ad->flamesize));
    printf("  blocksize    : %d\n",ad->flamesize);
    printf("  bit/sample   : %d\n",ad->bitpersmpl);
    printf("  totalblocks  : %ld\n",ad->flames);
    printf("  dataoffset   : %ld\n",ad->hlen);
    printf("  datasize     : %ld\n",ad->datalen);
    putchunklist(ch,chunks);
    printf("\n");
}

void putlongau(char *fname,long int fsize,Snddata *sd,int param[])
{
    int blocksize,bitpersmpl;

    printf("%s : AU, %ld Byte\n",fname,fsize);
    printf("  formatID: %04lxH",sd->fmcode);
    switch(sd->fmcode){
    case 1: printf(" (mu-Law)\n"); bitpersmpl=8; break;
    case 2: printf(" (linear)\n"); bitpersmpl=8; break;
    case 3: printf(" (linear)\n"); bitpersmpl=16; break;
    case 4: printf(" (linear)\n"); bitpersmpl=24; break;
    case 5: printf(" (linear)\n"); bitpersmpl=32; break;
    default: printf(" (unknown encoding)\n"); bitpersmpl=8; break;
    }
    blocksize=sd->channel*bitpersmpl/8;
    printf("  channel      : %ld\n",sd->channel);
    printf("  samplingrate : %ld\n",sd->smplrate);
    printf("  byte/sec     : %ld\n",sd->smplrate*blocksize);
    printf("  blocksize    : %d\n",blocksize);
    printf("  bit/sample   : %d\n",bitpersmpl);
    printf("  totalblocks  : %ld\n",sd->datalen/blocksize);
    printf("  dataoffset   : %ld\n",sd->hlen);
    printf("  datasize     : %ld\n",sd->datalen);
    printf("\n");
}

void putchunklist(Chunk *ch,int chunks)
{
    int j;
    Chunk *p;

    printf("  chunks :\n");
    for(j=1;j<=chunks;j++){
	p=&(ch[j-1]);
	printf("  [%d] \"%c%c%c%c\" (size: %ld, start: %ld)\n",j,
	       (p->id)[0],(p->id)[1],(p->id)[2],(p->id)[3],p->size,p->start);
    }
}

/* ##### ϴؿ (û) ##### */
void putdefaultheader(int param[])
{
    printf("TYPE smplrate encode ch bit totalblocks");
    if(param[BlockSize]) printf(" bs");
    if(param[DataSize]) printf(" totaldatasize");
    if(param[DataOffset]) printf(" datastart");
    printf("   filesize filename\n");
}

void putwav(char *fname,long int fsize,WAVdata *wd,int param[])
{
    printf(" WAV %8ld",wd->smplrate);
    switch(wd->fmcode){
    case 1: printf(" linear"); break;
    case 6: printf("  A-Law"); break;
    case 7: printf(" mu-Law"); break;
    default: printf("  %04xh",wd->fmcode); break;
    }
    printf(" %2d %3d",wd->channel,wd->bitpersmpl);
    if(wd->blocksize!=0) printf(" %11ld",wd->datalen/wd->blocksize);
    else printf(" -----------");
    if(param[BlockSize]) printf(" %2d",wd->blocksize);
    if(param[DataSize]) printf(" %13ld",wd->datalen);
    if(param[DataOffset]) printf(" %9ld",wd->hlen);
    printf(" %10ld %s\n",fsize,fname);
}

void putaiff(char *fname,long int fsize,AIFFdata *ad,int param[])
{
    int xi;

    printf("AIFF");
    xi=(int)((ad->smplrate).x);
    if((ad->smplrate).x-xi<0.1 && (ad->smplrate).x-xi>-0.1) /* xi Ȥ */
      printf(" %8d",xi);
    else
      printf(" %8.1f",(ad->smplrate).x+0.05);
    printf(" linear");
    printf(" %2d %3d",ad->channel,ad->bitpersmpl);
    printf(" %11ld",ad->flames);
    if(param[BlockSize]) printf(" %2d",ad->flamesize);
    if(param[DataSize]) printf(" %13ld",ad->datalen);
    if(param[DataOffset]) printf(" %9ld",ad->hlen);
    printf(" %10ld %s\n",fsize,fname);
}

void putau(char *fname,long int fsize,Snddata *sd,int param[])
{
    int bitpersmpl,blocksize;

    printf("  AU %8ld",sd->smplrate);
    switch(sd->fmcode){
    case 1: printf(" mu-Law"); bitpersmpl=8; break;
    case 2: printf(" linear"); bitpersmpl=8; break;
    case 3: printf(" linear"); bitpersmpl=16; break;
    case 4: printf(" linear"); bitpersmpl=24; break;
    case 5: printf(" linear"); bitpersmpl=32; break;
    default: printf("  %04lxh",sd->fmcode); bitpersmpl=8; break;
    }
    printf(" %2ld %3d",sd->channel,bitpersmpl);
    blocksize=sd->channel*bitpersmpl/8;
    printf(" %11ld",sd->datalen/blocksize);
    if(param[BlockSize]) printf(" %2d",blocksize);
    if(param[DataSize]) printf(" %13ld",sd->datalen);
    if(param[DataOffset]) printf(" %9ld",sd->hlen);
    printf(" %10ld %s\n",fsize,fname);
}

/* ##### usage ##### */
void usage(void)
{
    char *mess[]={
	"Usage: aufinfo (-m[mode]) (-b) (-t) (-s) [file] ([file]...)",
	" [mode] =0: ǡ (default)",
	"        =1: ܺٽ",
	" -b: 1 ֥åΥɽ (default: ʤ)",
	" -t: ǡ (=֥åߥ֥å) ɽ"
	" (default: ʤ)",
	" -s: ǡϰ֤ɽ (default: ʤ)",
	NULL
    };
    int j;

    for(j=1;mess[j-1]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j-1]);
}

