/* ǡ volume Ѥ 
 * 12/27 2003
 * shige
 * sndvol.c
 *
 * $Id: sndvol.c,v 1.6 2008-04-22 18:45:48+09 shige Exp $
 */
/* sndvol (-o [outfile]) -v[n] ([infile])
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

#undef DEBUG1

#define Voldelimit ':'
#define Maxchannel 10

int main(int argc,char *argv[]);
int setvolume(char *str,double vol[]);
int getarg(int argc,char **argv,double vol[],FILE **infile,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    SNDheader snd;
    FILE *infile,*outfile;
    int format,ret;
    double vol[Maxchannel];
    long int blocks,j,bs;
    int ch,k;
    
    if((ret=getarg(argc,argv,vol,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
	fprintf(stderr,"Error: In getSNDheader(). (%d)\n",format);
	return 1;
    }
#ifdef DEBUG1
    {
	int j;

	fprintf(stderr,"return = %d\n",ret);
	for(j=1;j<=SNDchannels(&snd,format);j++)
	  fprintf(stderr,"vol[%d]=%f\n",j-1,vol[j-1]);
	fprintf(stderr,"=====\n");
	for(;j<=Maxchannel;j++)
	  fprintf(stderr,"vol[%d]=%f\n",j-1,vol[j-1]);
    }
#endif
    ch=SNDchannels(&snd,format);
    if(ret-1>ch || ch>Maxchannel){ 
	fprintf(stderr,"Channel number error. (%d,%d,%d)\n",
		ret-1,ch,Maxchannel);
	return 2;
    }
    put1SNDheader(outfile,&snd,format);
    blocks=SNDblocks(&snd,format);
    for(j=1;j<=blocks;j++)
      for(k=1;k<=ch;k++)
	if(vol[k-1]==0.0) SNDputnull1ch(outfile,&snd,format);
	else SNDreadput1chdatavol(infile,outfile,&snd,format,vol[k-1]);
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}

int getarg(int argc,char **argv,double vol[],FILE **infile,FILE **outfile)
{
    int j,maxchannel=0;

    *outfile=stdout;
    *infile=stdin;

    for(j=1;j<=Maxchannel;j++) vol[j-1]=1.0;
    j=-1;
    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'v': 
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -1;
		    else argv++;
		}
		if((j=setvolume(*argv,vol))<0) return -2;
		if(j>maxchannel) maxchannel=j;
		break;
	    case 'h':
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0) return -4;
		    else argv++;
		}
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case '\0': break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(argc>1 || j<0) return -7;
    else if(argc<1) return maxchannel+1;
    else if(!strcmp(*argv,"-") ||(*infile=fopen(*argv,"r"))!=NULL){
	return maxchannel+1;
    }
    else{
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -9;
    }
}

int setvolume(char *str,double vol[])
{
    int len=strlen(str),j,k,ch;
    char *s;
    double x;

#ifdef DEBUG1
    fprintf(stderr,"DEBUG1: str=[%s]\n",str);
#endif
    if(len<=0) return -1;
    s=str; k=0; ch=0;
    for(j=1;j<=len;j++){
	if(*s==Voldelimit){
	    if(++k>=2) return -2;
	    *s='\0';
	    if((ch=atoi(str))<=0 || ch>Maxchannel) return -3;
	    vol[ch-1]=atof(s+1);
	    return ch;
	}
	s++;
    }
    x=atof(str);
    for(j=1;j<=Maxchannel;j++) vol[j-1]=x;
    return 0;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndvol (-o [outfile]) -v[n1] (-v[n2] ...) ([infile])",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   -v[string]: volume ͤλ",
	"   [infile]: ϥե (ά: ɸ)",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	" [2] volume ϰʲ̤:",
	"       -v[vol]     : ٤Ƥ channel  [vol] ",
	"       -v[n]:[vol] : [n] channel Τߤ [vol] ",
	"     [n]  1 ʾ[vol] Ǥդμ¿ (ͤ)",
	"     ͤϰ꤬ȿž롣",
	" [3] -v ϸλ꤬λ񤭤롣ä㤨",
	"        -v2 -v1:-0.5 -v1:1.2",
	"     ϡ1 channel  1.2 ܡ¾ channel  2 ܤˤ롣",
	" [4] ꤵʤä channel ϲ⤷ʤ",
#if 0
	" [5] [Ψ] ͤμˤ atof() ȤΤǡʤͤꤹȡ",
	"     Ƥ channel ͤ 0 ˤʤǽΤդɬס",
#endif
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
