/* gnuplot  table Ϥ򲻤ˤġ
 * shige
 * 08/29 2005
 * tbl2snd.c
 *
 * $Id: tbl2snd.c,v 1.2 2005-08-29 18:25:20+09 shige Exp $
 */
/* tbl2snd ([option])
 * [option]:
 *   -au/wav/aiff: format (default: au)
 *   -s [n]: sampling rate
 *   -b [n]: bit length
 *   -v [n]: volume
 *   -t [n]: ȷ (ֹ)
 *   -o [file]: output file
 *
 *   -l [n]: Ĺ (ߥ/b ǥ֥å: default: 5000)
 *   -hm [n]: 㲻 (default: C0)
 *   -hM [n]: ǹⲻ (default: C1)
 *
 *   -m1/m2 : ʣΥդιʬΥˡ (/̥ͥ)
 *      (default: m1)
 *   -u1/u2 : ʣΥդȷѤ/Ѥʤ 
 *      (default: u1)
 *   -d1/d2 : 'i' ΥǡΤ߻/'o' Υǡ
 *      (default: d1)
 *
 *   * -xm/-xM: [xm:xM] (x ϰ) <== ߤ̤ݡ
 *   * -ym/-yM: [ym:yM] (y ϰ) <== ߤ̤ݡ
 * 
 * ȷϤĤѰդơ­ʤ cyclic ˲󤹡
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "common.h"

typedef struct {
    double x,y;
    /* double h,t; */
    char R;
} TBLdata;

#define Maxbuff 8192
#define Minhz 15.0
#define Maxhz 100000.0
#define Maxchannels 8
#define Minsmplrate 100
#define Maxsmplrate 200000
#define Maxdatanum 5000
#define Maxgraphs 20

#define Default_volume 0.7
#define Default_basepitch 440.0
#define Default_hm 261.6256
#define Default_hM 523.2511
#define Default_T 5.0

#if 0
# define Default_AU_ch 1
# define Default_WAV_ch 1
# define Default_AIFF_ch 1
#endif
#define Default_AU_smpl 8000
#define Default_WAV_smpl 11025
#define Default_AIFF_smpl 11025
#define Default_AU_bit 8 /* fix */
#define Default_WAV_bit 16
#define Default_AIFF_bit 16

#define TBLalloc(n) ((TBLdata *)malloc(sizeof(TBLdata)*(n))) 

/* ##### ѿ ##### */
double xm,xM,ym,yM,T,hm,hM;

/* ##### prototype ##### */
int main(int argc,char *argv[]);
double pergene1(double x,double a);
double pergene2(double x,double a);
double pergene3(double x,double a,double b);
double per0(double x);
double per1(double x);
double per2(double x);
double per3(double x);
double per4(double x);
double per5(double x);
double per6(double x);
double per7(double x);
double perf(double x,int type);
int putglisdata3(FILE *outfile,SNDheader *snd,int format,double vol,int type,
	       TBLdata *data[],int N[],int M,int mmode,int umode,int dmode);
double xy2level(double t,int ch,TBLdata *data[],int N[],int M,int type,
		int mode);
double interpXY(double x,double x0,double x1,double y0,double y1);
double gethz(char c1,char c2,int oct,double base);
int setsndheader2(SNDheader *Snd,int oform,int ch,int smpl,int bit,char *lenstr);
void TBLcpy(TBLdata *new,TBLdata *org,int n);
void TBLcpy(TBLdata *new,TBLdata *org,int n);
int chdata(TBLdata *data,int mode);
int chdatan(TBLdata *data,int mode,int n);
int getdata2(FILE *infile,TBLdata *data[],int N[],int *M,int dmode);
int setMaxMin(TBLdata *data[],int N[],int M,int mode);
double str2hz(char *s,double basep);
int getarg(int argc,char **argv,int *oform,int *smpl,int *bit,double *vol,
	   int *type,int *mmode,int *umode,int *dmode,char **lenstr,
	   FILE **infile,FILE **outfile);
void usage(int ret);

/* #####  ##### */
int main(int argc,char *argv[])
{
    FILE *infile,*outfile;
    SNDheader snd;
    double vol;
    int type,smpl,bit,ch,mmode,umode,dmode,ret,format;
    TBLdata *data[Maxgraphs];
    int N[Maxgraphs],M;
    char *lenstr;
    
    if((ret=getarg(argc,argv,&format,&smpl,&bit,&vol,&type,
		   &mmode,&umode,&dmode,&lenstr,&infile,&outfile))<=0){
	usage(ret); return -ret;
    }
    if((ret=getdata2(infile,data,N,&M,dmode))<0){
	usage(ret-30); return -ret;
    }
    if(mmode==1) ch=1;
    else ch=M;
    if((ret=setsndheader2(&snd,format,ch,smpl,bit,lenstr))<0){
	usage(ret-40); return -ret;
    }
    putallSNDheader(outfile,&snd,1,format);
    ret=putglisdata3(outfile,&snd,format,vol,type,data,N,M,mmode,umode,dmode);
    if(ret<0){
	usage(ret-50); return -ret;
    }
    else return 0;
}

/* ########## ؿ ########## */
/* ##### ؿ ##### */
/* a>1 ==> -1<=pergene1(x,a)<=1 */
double pergene1(double x,double a)
{
    double y;

    y=(a*cos(2.0*M_PI*x)+1.0)/(a+1.0);
    return 2.0*y*y-1.0;
}

/* 0<a<1
 * 
 */
double pergene2(double x,double a)
{
    int j;

    j=x;
    return (x-j<a)?(-1.0):1.0;
}


/* 0<a<1, -1<b<1 
 * (0,0),(a,1),(1,b) ľ
 */
double pergene3(double x,double a,double b)
{
    int j;

    j=x;
    x-=j;
    return (x<a)?(2.0*x/a-1.0):((2.0)*(1.0-x)/(1.0-a)+b);
}

/* ##### perl?():  1,  -1.0~1.0 ##### */
/*  */
double per0(double x)
{
    return sin(2.0*M_PI*x);
}

/* Υ */
double per1(double x)
{
    int j;

    j=x;
    return 2.0*(x-j)-1.0;
}

/*  */
double per2(double x)
{
    return pergene2(x,0.5);
}

/* A(cos(x)+0.5*cos(x))+B */
double per3(double x)
{
    return pergene1(x,2.0);
}

/*  (Ϣ³) */
double per4(double x)
{
    return pergene3(x,0.5,-1.0);
}

/*  */
double per5(double x)
{
    return pergene2(x,0.25);
}

/* A(cos(x)+2.0*cos(x))+B */
double per6(double x)
{
    return pergene1(x,8.0);
}

/* ͳ (Ϣ³) */
double per7(double x)
{
    return pergene3(x,0.3,0);
}

double perf(double x,int type)
{
    switch(type%8){
    case 0: return per0(x);
    case 1: return per1(x);
    case 2: return per2(x);
    case 3: return per3(x);
    case 4: return per4(x);
    case 5: return per5(x);
    case 6: return per6(x);
    case 7: return per7(x);
    default: return 0.0;
    }
}

int putglisdata3(FILE *outfile,SNDheader *snd,int format,double vol,int type,
	       TBLdata *data[],int N[],int M,int mmode,int umode,int dmode)
{
    long int blocks,j;
    int ch,k,bs;
    double z,z0,smpl,t;
    int mode,ctype;

    mode=2-dmode;
    ch=(mmode==1)?1:M;
    if(ch!=SNDchannels(snd,format)) return -1;
    bs=SNDblocksize(snd,format);
    if((blocks=SNDblocks(snd,format))<=0
       ||(smpl=SNDsmplrate(snd,format))<=0) return -2;
    for(j=0;j<blocks;j++){
	t=j/smpl;
	ctype=type;
	if(mmode==1){ /*  */
	    z=0.0;
	    for(k=1;k<=M;k++){
		if((z0=xy2level(t,k,data,N,M,ctype,mode))<-1.0){
#ifdef DEBUG4
		    fprintf(stderr,"(t,k,M,ctype,mode,z0)=(%f,%d,%d,%d,%d,%f)\n",
			    t,k,M,ctype,mode,z0);
#endif
		    return z0;
		}
		z+=z0;
		if(umode==1) ctype++;
	    }
	    SNDput1chleveldata(outfile,z*vol/M,snd,format);
	}
	else{ /* ̥ͥ */
	    for(k=1;k<=M;k++){ 
		if((z=xy2level(t,k,data,N,M,ctype,mode))<-1.0){
#ifdef DEBUG4
		    fprintf(stderr,"(t,k,M,ctype,mode,z)=(%f,%d,%d,%d,%d,%f)\n",
			    t,k,M,ctype,mode,z);
#endif
		    return z-10;
		}
		SNDput1chleveldata(outfile,z*vol,snd,format);
		if(umode==1) ctype++;
	    }
	}
    }
    if(format!=E_AU && bs%2 && blocks%2) fputc(0,outfile);
    return 0;
}

#define NULLsnd 0.0

/* mode==0: 'o' Ĵ٤롢mode==1: 'i' ΤĴ٤
 */
/* M: graph θĿ
 * data[0] ~ data[M-1]: data ؤΥݥ
 * data[j][0] ~ data[j][N[j]-1]: data 줾
 * ch: ֹ (1<=ch<=M) 
 * m[j]: Ǹ x<data[j][m[j]] ä m[j] (-1: ͭʥǡϤϤʤ)
 * nullf[j]: ̵ǡä
 * off[j]: offset 
 */
double xy2level(double t,int ch,TBLdata *data[],int N[],int M,int type,
		int mode)
{
    static int first=1;
    static int *m,*nullf;
    static double *off;
    int j,k;
    double x,z;

    if(first){
	if((m=(int *)malloc(sizeof(int)*M))==NULL
	   ||(nullf=(int *)malloc(sizeof(int)*M))==NULL
	   ||(off=(double *)malloc(sizeof(double)*M))==NULL) return -10.0;
	for(j=0;j<M;j++){ 
	    off[j]=0.0;
	    nullf[j]=1;
	    for(k=0;k<N[j];k++) 
	      if(chdata(&(data[j][k]),mode)){ m[j]=k; break; }
	    if(k>=N[j]) m[j]=-1;
	}
	first=0;
    }
    if(ch<1 || ch>M) return -11.0;
    if(m[ch-1]<0) return NULLsnd; /* ̵ */
    x=xm+(xM-xm)*t/T;
    if(nullf[ch-1] && x<=data[ch-1][m[ch-1]].x) return NULLsnd; /* ̵ */
    if(x>data[ch-1][m[ch-1]].x){
	for(k=m[ch-1];k<N[ch-1];k++){
	    if(chdata(&(data[ch-1][k]),mode)){ /* ͭʥǡ */
		if(nullf[ch-1]){
		    if(x<=data[ch-1][k].x){
			m[ch-1]=k; 
			return NULLsnd; /* ̵ */
		    }
		    else
			nullf[ch-1]=0;
		}
		else if(x<=data[ch-1][k].x){
		    m[ch-1]=k;
		    break;
		}
		else{ /* k-1,k ɲ */ 
		    z=interpXY(data[ch-1][k].x,
			       data[ch-1][k-1].x,data[ch-1][k].x,
			       data[ch-1][k-1].y,data[ch-1][k].y);
		    if(z<0.0) return -12.0;
		    off[ch-1]+=z;
		}
	    }
	    else{
		off[ch-1]=0.0;
		nullf[ch-1]=1; 
	    }
	}
	if(k>=N[ch-1]){
	    m[ch-1]=-1; return NULLsnd; /* ̵ */
	}
    }
    k=m[ch-1];
    z=interpXY(x,data[ch-1][k-1].x,data[ch-1][k].x,
	       data[ch-1][k-1].y,data[ch-1][k].y);
    if(z<0.0){
#ifdef DEBUG4
	fprintf(stderr,"interpXY(%f,%f,%f,%f,%f)=%f\n",
		x,data[ch-1][k-1].x,data[ch-1][k].x,
		data[ch-1][k-1].y,data[ch-1][k].y,z);
	fprintf(stderr,"(xm,xM,ym,yM,hm,hM,T)=(%f,%f,%f,%f,%f,%f,%f)\n",
		xm,xM,ym,yM,hm,hM,T);
#endif
	return -13.0;
    }
    return perf(z+off[ch-1],type);
}

double interpXY(double x,double x0,double x1,double y0,double y1)
{
    double hr,H,z;
    
    if(hm<Minhz || hM>Maxhz || hM<=hm || xm>=xM || ym>=yM) return -1.0;
    if(x1<=x0 || x0<xm || x1<xm || x0>xM || x1>xM) return -2.0;
    if(y0<ym || y1<ym || y0>yM || y1>yM) return -3.0;
    hr=hM/hm;
    H=hm*pow(hr,(y0-ym)/(yM-ym));
    if(y0==y1) return H*T*(x-x0)/(xM-xm);
    z=H*T*(x1-x0)*(yM-ym)/((y1-y0)*(xM-xm));
    return z*(pow(hr,(y1-y0)*(x-x0)/((yM-ym)*(x1-x0)))-1.0)/log(hr);
}

/* 椯椯ϡΧԥ饹⥵ݡȤ
 */
double gethz(char c1,char c2,int oct,double base)
{
    /* ʿΧܿ */
    double mean[12];
    int tr[]={9,11,0,2,4,5,7},d,j;
    double x;

    if(c1<'A' || c1>'G') return -1.0;
    if(c2!=0 && c2!='#' && c2!='b') return -2.0;
    mean[0]=1.0;
    for(j=1;j<12;j++) mean[j]=pow(2.0,(double)j/12.0);

    d=tr[c1-'A'];
    if(c2=='#'){
	if(++d>=12){ oct++; d-=12; }
    }
    else if(c2=='b'){
	if(--d<0){ oct--; d+=12; }
    }
    x=base*mean[d]/mean[9];
    if(oct<0) for(;oct<0;oct++) x/=2.0;
    else if(oct>0) for(;oct>0;oct--) x*=2.0;
    if(x<Minhz || x>Maxhz) return -3.0;
    else return x;
}

int setsndheader2(SNDheader *Snd,int oform,int ch,int smpl,int bit,char *lenstr)
{
    double len;
    char buff[Maxbuff];
    long int blocksize;
    int j;

    switch(oform){
    case E_AU:
	(Snd->au).channel=ch;
	(Snd->au).smplrate=(smpl<0)?Default_AU_smpl:smpl;
	(Snd->au).magic=sto4bytei(".snd");
	(Snd->au).fmcode=1;
	(Snd->au).hlen=32;
	(Snd->au).str=NULL;
	break;
    case E_WAV:
	(Snd->wav).channel=ch;
	(Snd->wav).smplrate=(smpl<0)?Default_WAV_smpl:smpl;
	(Snd->wav).bitpersmpl=(bit<0)?Default_WAV_bit:bit;
	(Snd->wav).blocksize=(Snd->wav).channel*(Snd->wav).bitpersmpl/8;
	(Snd->wav).bytepersec=(Snd->wav).blocksize*(Snd->wav).smplrate;
	(Snd->wav).fmcode=1;
	(Snd->wav).hlen=44;
	break;
    case E_AIFF:
	(Snd->aiff).channel=ch;
	(Snd->aiff).bitpersmpl=(bit<0)?Default_AIFF_bit:bit;
	(Snd->aiff).hlen=44+IEEEExtendedBytes;
	(Snd->aiff).smplrate.x=(smpl<0)?Default_AIFF_smpl:smpl;
	ConvertToIeeeExtended((Snd->aiff).smplrate.x,(Snd->aiff).smplrate.s);
	(Snd->aiff).flamesize=(Snd->aiff).channel*(Snd->aiff).bitpersmpl/8;
	break;
    default: return -1;
    }
    if(lenstr==NULL ||(j=strlen(lenstr))<=0){ /* T Ȥ */
	blocksize=T*SNDsmplrate(Snd,oform);
    }
    else if(j>=Maxbuff) return -2;
    else{
	strcpy(buff,lenstr);
	if(buff[j-1]=='b'){ /* block */
	    buff[j-1]='0';
	    if((blocksize=atoi(lenstr))<=0) return -2;
	}
	else{
	    if((len=atof(lenstr))<=0.0) return -3;
	    blocksize=len*SNDsmplrate(Snd,oform)/1000;
	}
	T=blocksize/SNDsmplrate(Snd,oform);
    }
    switch(oform){
    case E_AU: 
	(Snd->au).datalen=blocksize*(Snd->au).channel; 
	break;
    case E_WAV: 
	(Snd->wav).datalen=blocksize*(Snd->wav).blocksize;
	break;
    case E_AIFF: 
	(Snd->aiff).flames=blocksize;
	(Snd->aiff).datalen=blocksize*(Snd->aiff).flamesize;
	break;
    }
    return 0;
}

#if 0
void TBLcpy(TBLdata *new,TBLdata *org,int n)
{
    int j;

    for(j=1;j<n;j++){
	new->x=org->x;
	new->y=org->y;
	new->R=org->R;
	new++; org++;
    }
    new->x=org->x;
    new->y=org->y;
    new->R=org->R;
}
#else
void TBLcpy(TBLdata *new,TBLdata *org,int n)
{
    int j;

    for(j=1;j<n;j++,new++,org++) *new=*org;
    *new=*org;
}
#endif

/* mode==0: 'o' Ĵ٤롢mode==1: 'i' ΤĴ٤
 */
int chdata(TBLdata *data,int mode)
{
    if(mode==0 && data->R!='u') return 1;
    if(mode==1 && data->R=='i') return 2;
    return 0;
}

/* mode==0: 'o' Ĵ٤롢mode==1: 'i' ΤĴ٤
 */
int chdatan(TBLdata *data,int mode,int n)
{
    int j;

    for(j=1;j<=n;j++) if(chdata(&data[j-1],mode)) return 1;
    return 0;
}

int getdata2(FILE *infile,TBLdata *data[],int N[],int *M,int dmode)
{
    TBLdata databuff[Maxdatanum];
    char strbuff[Maxbuff];
    int len,ret,n,mode;

    *M=0;
    n=0;
    mode=2-dmode;
    while(fgets(strbuff,Maxbuff,infile)!=NULL){
	if((len=strlen(strbuff))>=Maxbuff-2) return -1;
	if(strbuff[0]=='\n'){ /* ǡν */ 
	    if(n>0){
		if(chdatan(databuff,mode,n)){ /* ͭʥǡ */
		    if(++(*M)>Maxgraphs) return -4;
		    if((data[*M-1]=TBLalloc(n))==NULL) return -5;
		    TBLcpy(data[*M-1],databuff,n);
		    N[*M-1]=n;
		}
		n=0;
	    }
	}
	else if(strbuff[0]!='#'){ /* ġΥǡ */
	    if(++n>Maxdatanum) return -2;
	    if(sscanf(strbuff,"%lf %lf %c",&(databuff[n-1].x),
		      &(databuff[n-1].y),&(databuff[n-1].R))!=3) 
	      return -3;
	}
    }
    if((ret=setMaxMin(data,N,*M,mode))>0){
	if(ret%2) return -10;
	if(ret/2){
	    if(ym==0.0){ ym=-1.0; yM=1.0; }
	    else if(ym>0.0){ ym*=0.5; yM*=1.5; }
	    else{ ym*=1.5; yM*=0.5; }
	    return 1;
	}
	else return -11;
    } 
    return 0;
}

/* mode==0: 'o' Ĵ٤롢mode==1: 'i' ΤĴ٤
 * return value:
 *  xm==xM ==> +1
 *  ym==yM ==> +2
 */
int setMaxMin(TBLdata *data[],int N[],int M,int mode)
{
    int n,m,ret;
    double X,Y;

    for(m=1;m<=M;m++){
	for(n=1;n<=N[m-1];n++) if(chdata(&data[m-1][n-1],mode)) break;
	if(n<=N[m-1]) break;
    }
    if(m>M || n>N[m-1]) return -1;
    xm=xM=data[m-1][n-1].x;
    ym=yM=data[m-1][n-1].y;

    for(;m<=M;m++){
	for(;n<=N[m-1];n++) 
	  if(chdata(&data[m-1][n-1],mode)){
	      if((X=data[m-1][n-1].x)<xm) xm=X;
	      else if(X>xM) xM=X;
	      if((Y=data[m-1][n-1].y)<ym) ym=Y;
	      else if(Y>yM) yM=Y;
	  }
	n=1;
    }
    ret=0;
    if(xm==xM) ret+=1;
    if(ym==yM) ret+=2;
    return ret;
}

double str2hz(char *s,double basep)
{
    char c1,c2;
    int oct;

    if(*s == '-' ) return -1;
    if(isdigit(*s)) return atof(s);
    if((c1=*s)<'A' ||c1>'G') return -2;
    if(*(++s)=='\0'){ oct=0; c2=0; }
    else{
	if((c2=*s)=='#' || c2=='b') s++;
	else c2=0;
	if(*s=='\0') oct=0;
	else oct=atoi(s);
    }
    return gethz(c1,c2,oct,basep);
}

int getarg(int argc,char **argv,int *oform,int *smpl,int *bit,double *vol,
	   int *type,int *mmode,int *umode,int *dmode,char **lenstr,
	   FILE **infile,FILE **outfile)
{
    double basep=Default_basepitch;
    char c;

    *outfile=stdout;
    *vol=Default_volume;
    *smpl=-1; *bit=-1;
    *type=0;
    *oform=E_AU;
    hm=Default_hm; hM=Default_hM; T=Default_T;
    *lenstr=NULL;
    *mmode=1; *umode=1; *dmode=1;

    while(--argc>0){
	if(**(++argv)=='-'){
	    switch(*(++*argv)){
	    case 'H':
	    case '?': return 0;
	    case 'o':
		if(*outfile!=stdout) return -3;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if(!strcmp(*argv,"-")) *outfile=stdout;
		else if((*outfile=fopen(*argv,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",*argv);
		    return -5;
		}
		break;
	    case 's':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*smpl=atoi(*argv))<=Minsmplrate || *smpl>=Maxsmplrate){
		    fprintf(stderr,"Not correct s value (%s).\n",*argv);
		    return -11;
		}
		break;
	    case 'b':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*bit=atoi(*argv))!=8 && *bit!=16){
		    fprintf(stderr,"Not correct b value (%s).\n",*argv);
		    return -12;
		}
		break;
	    case 'v':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*vol=atof(*argv))<-1.0 || *vol>1.0){
		    fprintf(stderr,"Not correct v value (%s).\n",*argv);
		    return -12;
		}
		break;
	    case 'p':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((basep=atof(*argv))<=0.0){
		    fprintf(stderr,"Not correct p value (%s).\n",*argv);
		    return -15;
		}
		break;
	    case 't':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*type=atoi(*argv))<0){
		    fprintf(stderr,"Not correct t value (%s).\n",*argv);
		    return -13;
		}
		break;
	    case 'a':
	    case 'w':
		if(!strcmp(*argv,"au")) *oform=E_AU;
		else if(!strcmp(*argv,"wav")) *oform=E_WAV;
		else if(!strcmp(*argv,"aiff")) *oform=E_AIFF;
		else{
		    fprintf(stderr,"Unknown option (%s)\n",*argv);
		    return -14;
		}
	    case '\0': break;
	    case 'l':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		*lenstr=*argv;
		break;
	    case 'h':
		if(*(++*argv)!='m' && **argv!='M') return 0;
		c=**argv;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((c == 'm' && (hm=str2hz(*argv,basep))<Minhz)
		   ||(c == 'M' && (hM=str2hz(*argv,basep))>Maxhz)){
		    fprintf(stderr,"Not correct h%c value (%s).\n",c,*argv);
		    return -15;
		}
		break;
#if 0
	    case 'x':
		if(*(++*argv)!='m' && **argv!='M') return 0;
		c=**argv;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if(c == 'm') xm=atof(*argv);
		else xM=atof(*argv); 
		break;
	    case 'y':
		if(*(++*argv)!='m' && **argv!='M') return 0;
		c=**argv;
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if(c == 'm') ym=atof(*argv);
		else yM=atof(*argv); 
		break;
#endif
	    case 'm':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*mmode=atoi(*argv))!=1 && *mmode!=2){
		    fprintf(stderr,"Not correct mmode value (%s).\n",*argv);
		    return -16;
		}
		break;
	    case 'u':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*umode=atoi(*argv))!=1 && *umode!=2){
		    fprintf(stderr,"Not correct umode value (%s).\n",*argv);
		    return -17;
		}
		break;
	    case 'd':
		if(*(++*argv)=='\0'){ if(--argc<=0) return -4; else argv++; }
		if((*dmode=atoi(*argv))!=1 && *dmode!=2){
		    fprintf(stderr,"Not correct dmode value (%s).\n",*argv);
		    return -18;
		}
		break;
	    default: return -6;
	    }
	    if(**argv=='\0'){ --*argv; break; }
	}
	else break;
    }
    if(hm>=hM){
	fprintf(stderr,"Not correct (hm,hM) value (%f,%f)\n",hm,hM);
	return -8;
    }
#if 0
    /* xm,xM Ȥ줿 */
    if(xm>=xM){
	fprintf(stderr,"Not correct (xm,xM) value (%f,%f)\n",xm,xM);
	return -8;
    }
    /* ym,yM Ȥ줿 */
    if(ym>=yM){
	fprintf(stderr,"Not correct (ym,yM) value (%f,%f)\n",ym,yM);
	return -8;
    }
#endif
    if(argc!=1){
	return -9;
    }
    if(**argv == '-') *infile=stdin;
    else if((*infile=fopen(*argv,"r"))==NULL){
	return -10;
    }
    return 1;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: tbl2snd ([option]) [file]",
	"  [option]:",
	"    -au/wav/aiff: ǡ (default: AU)",
	"    -s[n]: ץ󥰼ȿ",
	"    -b[n]: ̻Ҳӥåȿ (8 or 16)",
	"    -v[n]: ܥ塼 (-1.0~1.0; default: 0.7)",
	"    -t[n]: () ȷ (default: )",
	"    -o[file]: ϥեλ (default: ɸ)",
	"    -p[n]: ܥԥå (A0 μȿ; default 440Hz)",
	"    -l[n]: Ĺ (ߥ or ֥åĹ; default: 5000)",
	"    -hm[n]: 㲻 (ȿ or ̾; default: C0)",
	"    -hM[n]: 㲻 (ȿ or ̾; default: C1)",
	"    -m[n]: ʣդι (1: 2: ̥ͥ; default: 1)",
	"    -u[n]: ʣդȷ (1: ȷ2: Ʊȷ; default: 1)",
	"    -d[n]: ѥǡ (1: 'i' Τ߻ѡ2:'o' ; default: 1)",
	" ",
	" [1] ϥե '-' ꤷ硢ޤϲꤷʤ",
	"     ɸϤˤʤ롣",
	" [2] table ǡ gnuplot  2D table ǡȤ롣ܤ gnuplot",
	"      help table ȡʤʣΥդζڤ϶ԤȤͭ",
	"     ǡ x ɸñĴä¤ǤȲꤹ롣",
	" [3] -m1 ξϥΥǡ (1 ͥ) Ȥʤꡢ-m2 ξ",
	"     ¿ͥǡȤʤ롣3 ͥʾΥǡ˺",
	"     Ǥʤǽ뤬 sndchan ɬפʥͥȴ",
	"     ȤäƺФ褤",
	" [4] ̵ʥǡʬ̵ˤʤ롣",
	" [5] ȷϸ 8 ѰդƤơդ 8 ¿",
	"     ( -u1 ξ) 餬Ū˻Ȥ롣-t λϤκ",
	"     ˻Ѥȷ (0~7) ̣롣",
	" [6] Ĺϡñʤͤξϥߥä򡢿ͤκǸ 'b' ",
	"      block Ḷ́롣λϤ벻Ĺ",
	"     (block Ĺ)/(ץ󥰼ȿ) [] Ȥʤ롣",
	" [7] ϡȿ (μ¿)ޤϲ̾ǻꤹ롣̾",
	"       [ե٥å](#|b)([])",
	"     ηǻꤹ롣줾졢",
	"       [ե٥å]: C (),D(),E(),F(ե),G(),A(),B()",
	"       #: Ⱦ夲롢b: Ⱦ (ά)",
	"       []: ֻ (,...,-3,-2,-1,0,1,2,3,...; ά)",
	"     ֿ̣礭⤤֤̣ά",
	"      0 Ȥ롣㤨СF#2, Cb, D-1 Τ褦˻ꤹ롣",
	"     ƲȼȿδطϡC0~C1 Ǥϰʲ̤ (A0=440Hz ξ)",
	"       C0: 261.6256Hz, C#0(=Db0): 277.1826Hz,",
	"       D0: 293.6648Hz, D#0(=Eb0): 311.1270Hz,",
	"       E0: 329.6276Hz,",
	"       F0: 349.2282Hz, F#0(=Gb0): 369.9944Hz",
	"       G0: 391.9954Hz, G#0(=Ab0): 415.3047Hz,",
	"       A0: 440.0000Hz, A#0(=Bb0): 466.1638Hz,",
	"       B0: 493.8833Hz,",
	"       C1: 523.2511Hz,",
	"       (ʿΧ)",
	"      1 ־夬 ()  2  (Ⱦʬ) ˤʤ롣",
	" [8] ̾ϡCb1=B0, B#0=C1, E#0=F0, Fb0=E0 Ȥ롣",
	" [9] ץ󥰼ȿΥǥեȤοͤϡǡ˰ۤʤ롣",
	"           | channel| sampling| bit ",
	"       ----+--------+---------+-------",
	"       AU  |  1ch   |  8000Hz |  8bit ",
	"       WAV |  2ch   | 11025Hz | 16bit ",
	"       AIFF|  2ch   | 11025Hz | 16bit ",
	NULL
    };
    int j;

#ifdef DEBUG1
    fprintf(stderr,"USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
